# 网络环境配置

# 一、官方提供的网络配置方式

[宇树机器狗连接网络的相关说明 (yuque.com)](https://www.yuque.com/ironfatty/nly1un/ft1yvm)

## 1.Go1-Edu树莓派内置无线网卡设置

Go1-Edu运动控制主机树莓派上内置了一个可以用来连接WiFi的无线网卡wlan0（wlan1用来发射热点），有些时候，可以临时用来连接网络（但是更建议使用外置的无线或者有线的网卡）。

### 1.1连接WiFi

打开机器狗背部的盖子，将HDMI显示器和鼠标键盘插在靠近网口的接口上。

![https://cdn.nlark.com/yuque/0/2022/png/25836858/1641644621487-d10866d4-fe52-44b9-b2d5-4ce1c4046594.png](https://cdn.nlark.com/yuque/0/2022/png/25836858/1641644621487-d10866d4-fe52-44b9-b2d5-4ce1c4046594.png)

在树莓派的桌面右上角，点击网络图标连接网络。

### 1.2设置路由表

如果连接上WiFi，但是无法上外网，可以尝试如下步骤：

打开终端：

```bash
ifconfig
#查看wlan0的网络信息，查看网关地址
ping 192.168.xxx.1
#xxx为上一步查看到的wlan0的地址，ping一下通不通，正常应该是通的
ping baidu.com
#ping一下百度，正常可以解析出IP，但是网络不可达，如果是这种情况，则执行下一步
sudo route add default gw 192.168.xxx.1
#添加无线网络的网关地址到路由表
ping baidu.com
#再次ping百度，可以ping通，正常已经可以上网
```

重启后，该设置会恢复，需要再次添加网关到路由表。

## 2.故障排除

### 2.1没有无线信号

如果在树莓派的桌面上无法连接WiFi，可以尝试如下步骤：

打开终端：

```bash
sudo ifconfig wlan0 down
sudo ifconfig wlan0 up
```

此时应该就可以通过桌面连接网络了。

# 二、搭建http代理服务器

机器狗内部程序依赖出厂环境，避免对机器狗内部环境及网络造成影响，采用此方式进行上网。

## 1.搭建代理服务器

[在 Ubuntu 22.04 | 20.04 | 安装和配置 Squid 代理服务器](Squid代理服务器.md)

## 2.**连接代理服务器**

```bash
sudo vim /etc/environment

export http_proxy="http://username:password@proxyipaddress:proxyport"
export https_proxy="http://username:password@proxyipaddress:proxyport"
export no_proxy="localhost, 127.0.0.1"
# 用代理的IP地址和端口替换proxyipaddress和proxyport。

export http_proxy="http://192.168.12.246:3128"
export https_proxy="http://192.168.12.246:3128"
export no_proxy="localhost, 127.0.0.1, 192.168.123.15, 192.168.123.14, 192.168.123.13, 192.168.123.161"
# 建议增加 192.168.123.*
# 接下来

sudo visudo
# 将下面的行添加到文件中，这样sudo将使用您刚刚创建的环境变量:

Defaults env_keep+="http_proxy https_proxy no_proxy"

# 重启
```

注：代理服务器需要连接机器狗的wifi，然后在需要网络的板子上进行上述配置之后，重启即可上网。